﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Document
{   // Virtual proxy for a  formatted-text-Document data structure:
    // It reads the text file and builds formatted lines only when forced to do so.
    // It saves the lines it does build in case they are needed again in the future.
    public class VProxyDoc : IDoc
    {
        private List<string> allLines;  // all the formatted lines in the document
        private WordIterator it;  // the iterator from which the words are read
                                  //    to construct the formatted lines
        private int lineLength;   // the (approximate) length of the formatted lines


        // opens the text file at position  path  on the disk  
        // and remembers the desired  lineLength.  Doesn't read any words yet,
        // doesn't build any formatted lines just yet.
        public VProxyDoc(string path, int lineLength) {
            // WRITE ME
        }

        // returns Line number  i  in the formatted text Document
        public string getLine(int i) {
             /* algorithm:
              *    if  line #i  already saved, then return it.
              *    else use the WordIterator,  it,  to read enough words that
              *       you build and save (all the lines up to and including) line #i.
              *       Hint: use method  addLine.
              *       return line #i
              */
              // WRITE ME
              return null;
        }

        // helper method that reads the text file, builds the next formatted line,
        //   and adds it to the end of  allLines
        // helper method that reads the text file, builds the next formatted line,
        //   and adds it to the end of  allLines
        private void addLine()  {
            string nextLine = "";
            while (nextLine.Length < lineLength && it.more())  {
                string word = it.next();
                nextLine = nextLine + " " + word;
            }
            allLines.Add(nextLine);
        }
    }
}
