﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Document;

namespace UnitTest
{
    class Program
    {
        static void Main(string[] args)
        {       
           testDocReader();  // run a demo document-reader program
        }

        // Two fields for the document reader:
        private static int lineNumber = 0;  // current line number
        // open text file,  hamlet.txt,  and format it for reading at approx 40 chars per line:  
        private static IDoc doc = new AllDoc("..\\..\\..\\hamlet.txt", 40);   // document-formatter object

        // once you write the virtual proxy for IDoc, comment out the previous line and use the following instead:
        //private static IDoc doc = new VProxyDoc("..\\..\\..\\hamlet.txt", 40);

        // console-window app for reading a formatted text document:
        private static void testDocReader() {
           Console.WriteLine();
           showLine(0);   // see below
           while (true) {
               string command = Console.ReadLine();
               if (command == "" ) { showNextLine(); }  // see below
               else if (command == "q") { return; }     // quit!
               else {  // parse the number in the command and show that line number:
                   int num = -1;   // see the line below:
                   if (int.TryParse(command, out num)) {
                       showLine(num);  }
               } 
           }
        }
        // displays line #n in the console window:
        private static void showLine(int n) {
            lineNumber = n;
            Console.Write(lineNumber + ": ");
            Console.Write(doc.getLine(lineNumber));
        }
        // displays the next line in the console window:
        private static void showNextLine() {
            showLine(lineNumber+1);
        }



       ///  OLDER UNIT TESTS:
       private static void test1() {
           WordIterator it = new WordIterator("..\\..\\..\\file0.txt");
            string line = "";
            while (line != null) {
                Console.Write("* ");
                line = it.next();
                Console.WriteLine(line);
            }
            it.close();
       }
       private static void test2() {
            AllDoc d = new AllDoc("..\\..\\..\\file0.txt", 6);
            for (int i = 0 ;  i < 15; i++) {
               Console.WriteLine(d.getLine(i)); }
            Console.ReadLine();
      }

    }
}
